import java.awt.event.*;
import java.io.*;
import javax.swing.*;

public class ConfigFileDialog extends JButton implements ActionListener {
	private String configFilePath;
	private String curDir;
	private JButton configButton;
	private JTextField textField;
	
	ConfigFileDialog(JTextField textfld, String caption){
		  curDir = System.getProperty("user.dir") + File.separator;
		  configButton = new JButton(caption);
		  configButton.addActionListener(this);
		  configFilePath = new String("");
		  textField = textfld;
	  }
	
	public void actionPerformed(ActionEvent ae){
		JFileChooser chooser = new JFileChooser(new File("."));
		chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		chooser.setMultiSelectionEnabled(false);
		String[] html = new String[] {"xml"};
		chooser.addChoosableFileFilter(new ExtFilter(html, "Xml Files (*.xml)"));
		int option = chooser.showOpenDialog(ConfigFileDialog.this);
		if (option == JFileChooser.APPROVE_OPTION) 
		{
			//chooser.getSelectedFile()
			
			File sf = chooser.getSelectedFile();
			String filelist = "nothing";
			try 
			{
					if(sf != null){
						filelist = sf.getCanonicalPath();
						configFilePath = filelist;
						//System.out.println("file is ->" + configFilePath);
						textField.setText(configFilePath);
					}
				
				
			}
			catch (IOException evt) 
			{
				System.out.println("Exception: "+evt);
			}
		}
	  }
	
	public JButton getConfigButton(){
		return configButton;
	}
	
	public String getConfigFilePath(){
		return configFilePath;
	}
}
