import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.*;
import javax.swing.*;

public class GraphMain extends JPanel implements ActionListener, Runnable {
	private dbConnection dbCon;
	private JPanel GraphPanel;
	private MyComboBox cbBox1;
	private MyComboBox cbBox2;
	private MyComboBox cbBox3;
	private MyCheckBox chkBox;
	private MyCheckBox compareLabel;
	private CancelButton mycancelButton;
	private JFrame frame;
	private JLabel compare;
	private JLabel comparewith;
	private MyGoButton goButton;
	private JButton myRefreshButton;
	
	public GraphMain(){
		dbCon = new dbConnection();
	}
	
	public void show(){
		//dbCon = new dbConnection();
		String cmd = "Select entry_name from config_info";
		ResultSet rs;
		int i = 0;
		String [] cbBoxOption = new String [100];
		rs = dbCon.createExecuteQuery(cmd);
		try{
			while(rs.next()){
				cbBoxOption[i++] = rs.getString("entry_name");
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		cbBox1 = new MyComboBox(cbBoxOption);
		cbBox2 = new MyComboBox(cbBoxOption);
		cbBox3 = new MyComboBox(cbBoxOption);
		chkBox = new MyCheckBox("Show Results of run", 15);
		compareLabel = new MyCheckBox("Compare Prev Runs", 15);
		compare = new JLabel("Compare");
		comparewith = new JLabel("with");
		
		myRefreshButton = new JButton("Refresh");
		myRefreshButton.addActionListener(this);
		
		mycancelButton = new CancelButton();
		goButton = new MyGoButton("Go");
		goButton.setCbBoxOne(cbBox1);
		goButton.setCbBoxTwo(cbBox2);
		goButton.setCbBoxThree(cbBox3);
		goButton.setCompareCheckBox(compareLabel);
		goButton.setShowResultsCheckBox(chkBox);
		goButton.setCompareOption(cbBoxOption);
		
		GraphPanel = new JPanel(new GridBagLayout());
		
		GraphPanel.setToolTipText("This panel is used to view summarized outputs of previous runs " +
		"or compare the outputs of 2 different runs.");		
		
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		c.anchor = GridBagConstraints.LINE_START;
		chkBox.getMyCheckBox().setToolTipText("Select this option if you would like to view " +
				"the results of a particular run.");
		GraphPanel.add(chkBox.getMyCheckBox(), c);
		c.gridx = 2;
		c.gridy = 0;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox3.getMyComboBox(), c);
		c.gridx = 0;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_START;
		compareLabel.getMyCheckBox().setToolTipText("Select this option if you would like to " +
				"comapre the results of 2 different runs");
		GraphPanel.add(compareLabel.getMyCheckBox(), c);
		c.gridx = 1;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_START;
		GraphPanel.add(compare, c);
		c.gridx = 2;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox1.getMyComboBox(), c);
		/*c.gridx = 3;
		c.gridy = 2;
		GraphPanel.add(new JLabel("    "), c);*/
		c.gridx = 3;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(comparewith, c);
		c.gridx = 4;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox2.getMyComboBox(), c);
		c.gridx = 5;
		c.gridy = 3;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(new JLabel("    "), c);
		
		
		c.gridx = 3;
		c.gridy = 5;
		c.anchor = GridBagConstraints.LINE_END;
		c.insets = new Insets(0, 0, 0, 10);
		myRefreshButton.setToolTipText("Click on this button to refresh the list of runs " +
				"provided in the combo boxes above.");
		GraphPanel.add(myRefreshButton, c);
		
		c.gridx = 4;
		c.gridy = 5;
		c.insets = new Insets(0, 10, 0, 0);
		c.anchor = GridBagConstraints.LINE_START;
		goButton.getMyGoButton().setToolTipText("Click on this button to view a list of available " +
				"outputs for the selected run.");
		GraphPanel.add(goButton.getMyGoButton(), c);
		c.gridx = 5;
		c.gridy = 5;
		c.insets = new Insets(0, 0, 0, 0);
		c.anchor = GridBagConstraints.LINE_START;
		GraphPanel.add(mycancelButton.getMyCancelButton(), c);
		
		
		 add(GraphPanel, BorderLayout.LINE_START);
	     setBorder(BorderFactory.createEmptyBorder(40,40,40,40));
	     setSize(1000, 500);
	     JFrame frame = new JFrame("P-Reg Graph Panel");
	     frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	        //Create and set up the content pane.
	     this.setOpaque(true); //content panes must be opaque
	     frame.setContentPane(this);
	     frame.pack();
	     frame.setVisible(true);
	     
	}
	
	private void refresh(){
		
		String cmd = "Select entry_name from config_info";
		ResultSet rs;
		int i = 0;
		String [] cbBoxOption = new String [100];
		rs = dbCon.createExecuteQuery(cmd);
		try{
			while(rs.next()){
				cbBoxOption[i++] = rs.getString("entry_name");
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		
		cbBox1 = new MyComboBox(cbBoxOption);
		cbBox2 = new MyComboBox(cbBoxOption);
		cbBox3 = new MyComboBox(cbBoxOption);
		
		goButton.setCbBoxOne(cbBox1);
		goButton.setCbBoxTwo(cbBox2);
		goButton.setCbBoxThree(cbBox3);
		goButton.setCompareOption(cbBoxOption);
		
		GridBagConstraints c = new GridBagConstraints();
		
		c.gridx = 2;
		c.gridy = 0;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox3.getMyComboBox(), c);
		
		c.gridx = 2;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox1.getMyComboBox(), c);
		
		c.gridx = 5;
		c.gridy = 2;
		c.anchor = GridBagConstraints.LINE_END;
		GraphPanel.add(cbBox2.getMyComboBox(), c);
		  
	}

	public void actionPerformed(ActionEvent e) {
		//frame.setVisible(false);
		//System.out.println("fsdfs");
		GraphPanel.remove(cbBox1.getMyComboBox());
		GraphPanel.remove(cbBox2.getMyComboBox());
		GraphPanel.remove(cbBox3.getMyComboBox());
		GraphPanel.repaint();
		refresh();
		GraphPanel.revalidate();
		
		//show();
		
	}

	public void run() {
		// TODO Auto-generated method stub
		show();
		
	}
}
