import java.awt.*;
import javax.swing.*;


public class MainPanel extends JPanel implements Runnable{
	
	JPanel checkPanel;
    static JFrame frame;
    
    MyCheckBox Stage0Button;
	MyCheckBox Stage1Button;
	MyCheckBox netSatButton;
    MyCheckBox iPerfButton;
    MyCheckBox diskPerfButton;
    MyCheckBox singleClientButton;
    MyCheckBox multipleClientButton;
    MyCheckBox autoReportButton;
    MyCheckBox singleClientLargeFileButton;
    MyCheckBox singleClientSmallFileButton;
    
    MyTextField minNumberOfClients;
    MyTextField maxNumberOfClients;
    MyTextField configFileTextField;
    MyTextField nameOfTheRunText;
    
    MyComboBox largeFileMinCbBox, largeFileMaxCbBox, smallFileMinCbBox, smallFileMaxCbBox;
    MyComboBox multipleClientMinFileSizeCbBox, multipleClientMaxFileSizeCbBox;
    MyComboBox minRecordSize, maxRecordSize;
    MyComboBox singleclientlargeRecSize,singleclientsmallRecSize;
    MyComboBox numOfRunsStageZero, numOfRunsSingleClient, numOfRunsMultipleClients;
    
    
    JLabel minSizeLabel, MaxSizeLabel, minSizeLabel2, MaxSizeLabel2;
    JLabel numClientLabel, fileSizeLabel, recordSizeLabel;
    JLabel configFileLabel, nameOfTheRun;
    JLabel minClientLabel, maxClientLabel;
    JLabel minMultipleClientFS, maxMultipleClientFS, MaxMultipleClientRecSz;
    JLabel MinMultipleClientRecSz, singleclientLargeRecSz, singlclientSmallRecsz;
    JLabel numOfRunsLabelStageZero;
    JLabel numOfRunsLabelSingleClient;
    JLabel numOfRunsLabelMultipleClient;
    
    MyRunButton runButton;
    ConfigFileDialog myBrowseButton;
    CancelButton cancelbutton;
    
    String[] minSmallFileOptions = { "64K", "128K", "256K", "512K", "1M", "2M", "4M"};
    String[] maxSmallFileOptions = { "64K", "128K", "256K", "512K", "1M", "2M", "4M"};
    String[] largeFileOptions = { "512MB", "1G", "2G", "4G", "8G"};
    String[] numOfRunsOptions = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};
    String[] recordsSizeOptions = {"4K", "8K", "16K", "32K", "64K", "128K", "256K", "512K", "1M", "2M", "4M", "8M", "16M"};
    String[] smallrecordsSizeOptions = {"4K", "8K", "16K", "32K", "64K", "128K", "256K", "512K", "1M", "2M", "4M"};
    String[] fileOptions = {"64K", "128K", "256K", "512K", "1M", "2M", "4M", "8M", "16M","32M","64M",
    		"128M","256M","512MB", "1G", "2G", "4G", "8G"};
    
    
    int LevelOneFont = 17;
    int levelTwoFont = 15;
    
   
    
    public MainPanel() {
    	super(new BorderLayout());
    	
    	checkPanel = new JPanel(new GridBagLayout());
    	
        Stage0Button = new MyCheckBox("Environment Check", LevelOneFont);
        Stage1Button = new MyCheckBox("Regression Phase", LevelOneFont);
        netSatButton = new MyCheckBox("NetSat", levelTwoFont);
        iPerfButton = new MyCheckBox("iPerf", levelTwoFont);
        diskPerfButton = new MyCheckBox("Disk Performance", levelTwoFont);
        singleClientButton = new MyCheckBox("Single Client", levelTwoFont);
        multipleClientButton = new MyCheckBox("Multiple Client", levelTwoFont);
        autoReportButton = new MyCheckBox("Auto Report", levelTwoFont);
        singleClientLargeFileButton = new MyCheckBox("Large Files", levelTwoFont);
        singleClientSmallFileButton = new MyCheckBox("Small Files", levelTwoFont);
        
        
        minNumberOfClients = new MyTextField(5);
        maxNumberOfClients = new MyTextField(5);
        configFileTextField = new MyTextField(20);
        nameOfTheRunText = new MyTextField(20);
        
        myBrowseButton = new ConfigFileDialog(configFileTextField.getMyTextField(), "Browse");
        cancelbutton = new CancelButton();
        
        minSizeLabel = new JLabel("Min Size");
        MaxSizeLabel = new JLabel("Max Size");
        minSizeLabel2 = new JLabel("Min Size");
        MaxSizeLabel2 = new JLabel("Max Size");
        numClientLabel = new JLabel("Clients");
        fileSizeLabel = new JLabel("File Size");
        recordSizeLabel = new JLabel("Record Size (KB)");
        MinMultipleClientRecSz = new JLabel("Min Size");
        MaxMultipleClientRecSz = new JLabel("Max Size");
        numOfRunsLabelStageZero = new JLabel("Number of Runs");
        numOfRunsLabelSingleClient = new JLabel("Number of Runs");
        numOfRunsLabelMultipleClient = new JLabel("Number of Runs");
        configFileLabel = new JLabel("Configuration File");
        nameOfTheRun = new JLabel("Save Results As");
        minClientLabel = new JLabel("Min Clients");
        maxClientLabel = new JLabel("Max Clients");
        singleclientLargeRecSz = new JLabel("Record Size");
        singlclientSmallRecsz = new JLabel("Record Size");
        minMultipleClientFS = new JLabel("Min Size");
        maxMultipleClientFS = new JLabel("Max Size");
        
        numClientLabel.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        fileSizeLabel.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        recordSizeLabel.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        numOfRunsLabelStageZero.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        numOfRunsLabelSingleClient.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        numOfRunsLabelMultipleClient.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        configFileLabel.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        nameOfTheRun.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
       // MinMultipleClientRecSz.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
       // MaxMultipleClientRecSz.setFont(new Font("TimesNewRoman", Font.BOLD, levelTwoFont));
        
        largeFileMinCbBox = new MyComboBox(largeFileOptions);
        largeFileMaxCbBox = new MyComboBox(largeFileOptions);
        smallFileMinCbBox = new MyComboBox(minSmallFileOptions);
        smallFileMaxCbBox = new MyComboBox(maxSmallFileOptions);
        multipleClientMaxFileSizeCbBox = new MyComboBox(fileOptions);
        multipleClientMinFileSizeCbBox = new MyComboBox(fileOptions);
        maxRecordSize = new MyComboBox(recordsSizeOptions);
        minRecordSize = new MyComboBox(recordsSizeOptions);
        numOfRunsStageZero = new MyComboBox(numOfRunsOptions);
        numOfRunsSingleClient = new MyComboBox(numOfRunsOptions);
        numOfRunsMultipleClients = new MyComboBox(numOfRunsOptions);
        singleclientlargeRecSize = new MyComboBox(recordsSizeOptions);
        singleclientsmallRecSize = new MyComboBox(smallrecordsSizeOptions);
        //Register a listener for the check boxes.
        
        runButton = new MyRunButton("Run", Stage0Button, Stage1Button, netSatButton,
        							iPerfButton, diskPerfButton, singleClientButton, 
        							multipleClientButton, autoReportButton, 
        							singleClientLargeFileButton, singleClientSmallFileButton, largeFileMinCbBox, largeFileMaxCbBox,
        							smallFileMinCbBox, smallFileMaxCbBox, 
        							minNumberOfClients, maxNumberOfClients,
        							multipleClientMinFileSizeCbBox, multipleClientMaxFileSizeCbBox, 
        							minRecordSize, maxRecordSize, 
        							numOfRunsStageZero, numOfRunsSingleClient, 
        							numOfRunsMultipleClients, myBrowseButton,
        							nameOfTheRunText, singleclientlargeRecSize, 
        							singleclientsmallRecSize);
       
        //Put the check boxes in a column in a panel
        
        GridBagConstraints c = new GridBagConstraints();
        //checkPanel.setBackground(Color.MAGENTA);
        c.gridx = 0;
        c.gridy = 0;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(configFileLabel, c);
        c.gridx = 1;
        c.gridy = 0;
        configFileTextField.getMyTextField().setToolTipText("Enter a xml formatted config file here.");
        checkPanel.add(configFileTextField.getMyTextField(), c);
        c.gridx = 2;
        c.gridy = 0;
        c.insets = new Insets(0, 5, 0, 0);
        myBrowseButton.getConfigButton().setToolTipText("Click this button to browse and search for" +
        		" a xml format config file.");
        checkPanel.add(myBrowseButton.getConfigButton(), c);
        
        // save as
        c.gridx = 0;
        c.gridy = 1;
        c.insets = new Insets(5, 0, 0, 0);
        checkPanel.add(nameOfTheRun, c);
        c.gridx = 1;
        c.gridy = 1;
        c.insets = new Insets(5, 0, 0, 0);
        nameOfTheRunText.getMyTextField().setToolTipText("Enter a name with which you would like to " +
        		"save this regression run");
        checkPanel.add(nameOfTheRunText.getMyTextField(), c);
        
        
        // stage zero
        c.gridx = 0;
        c.gridy = 2;
        Stage0Button.getMyCheckBox().setToolTipText("By checking this option you can run tests to " +
        		"check the environment setup.\n We recommend to run these tests atleast " +
        		"once on any new setup.");
        checkPanel.add(Stage0Button.getMyCheckBox(), c);
       
        // number of Runs
        c.gridx = 1;
        c.gridy = 3;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(numOfRunsLabelStageZero, c);
        c.gridx = 2;
        c.gridy = 3;
        numOfRunsStageZero.getMyComboBox().setToolTipText("This field sets the number of times you want" +
        		"to run the following Environment check tests. \n The final output that is provided is an" +
        		"average of these runs");
        checkPanel.add(numOfRunsStageZero.getMyComboBox(), c);
       
        // netsat
        c.gridx = 1;
        c.gridy = 4;
        netSatButton.getMyCheckBox().setToolTipText("NetSat is a network saturation tool that " +
        		"simulates traffic seen in parallel file systems." +
        		"The tool outputs the maximum network bandwidth available for such traffic.");
        checkPanel.add(netSatButton.getMyCheckBox(), c);
        
        // iperf
        c.gridx = 1;
        c.gridy = 5;
        iPerfButton.getMyCheckBox().setToolTipText("This test checks the bandwidth of the links" +
        		"between the different machines specified in the config file.");
        checkPanel.add(iPerfButton.getMyCheckBox(), c);
        
        // disk perf
        c.gridx = 1;
        c.gridy = 6;
        diskPerfButton.getMyCheckBox().setToolTipText("This test checks the performance of the " +
        		"cache and disks present on the Storage/data servers. \n" +
        		"NOTE: This test is only possible for ATA/SATA disks.");
        checkPanel.add(diskPerfButton.getMyCheckBox(), c);
        
        // stage one
        c.gridx = 0;
        c.gridy = 7;
        checkPanel.add(Stage1Button.getMyCheckBox(), c);
        
        // single clinet
        c.gridx = 1;
        c.gridy = 8;
        checkPanel.add(singleClientButton.getMyCheckBox(), c);
        
//      number of Runs
        c.gridx = 2;
        c.gridy = 9;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(numOfRunsLabelSingleClient, c);
        c.gridx = 3;
        c.gridy = 9;
        checkPanel.add(numOfRunsSingleClient.getMyComboBox(), c);
       
        // auto report
        c.gridx = 2;
        c.gridy = 10;
        autoReportButton.getMyCheckBox().setToolTipText("The single client auto report test runs" +
        		"Write and Read performance tests for File sizes varying from 64K to 512M and " +
        		"Record sizes varying from 4K to 16M\n");
        checkPanel.add(autoReportButton.getMyCheckBox(), c);
 
        
       // single client large file 
        c.gridx = 2;
        c.gridy = 11;
        c.insets = new Insets(5, 0, 0, 0);
        checkPanel.add(singleClientLargeFileButton.getMyCheckBox(), c);
        c.gridx = 3;
        c.gridy = 11;
        c.anchor = GridBagConstraints.LINE_END; 
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(minSizeLabel2, c);
        c.gridx = 4;
        c.gridy = 11;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(largeFileMinCbBox.getMyComboBox(), c);
        c.gridx = 5;
        c.gridy = 11;
        checkPanel.add(MaxSizeLabel2, c);
        c.gridx = 6;
        c.gridy = 11;
        checkPanel.add(largeFileMaxCbBox.getMyComboBox(), c);
        c.gridx = 7;
        c.gridy = 11;
        checkPanel.add(singleclientLargeRecSz, c);
        c.gridx = 8;
        c.gridy = 11;
        checkPanel.add(singleclientlargeRecSize.getMyComboBox(), c);
 
        // single client small file
        c.gridx = 2;
        c.gridy = 12;
        c.insets = new Insets(5, 0, 0, 0);
        checkPanel.add(singleClientSmallFileButton.getMyCheckBox(), c);
        c.gridx = 3;
        c.gridy = 12;
        c.anchor = GridBagConstraints.LINE_END;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(minSizeLabel, c);
        c.gridx = 4;
        c.gridy = 12;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(smallFileMinCbBox.getMyComboBox(), c);
        c.gridx = 5;
        c.gridy = 12;
        checkPanel.add(MaxSizeLabel, c);
        c.gridx = 6;
        c.gridy = 12;
        checkPanel.add(smallFileMaxCbBox.getMyComboBox(), c);
        c.gridx = 7;
        c.gridy = 12;
        checkPanel.add(singlclientSmallRecsz, c);
        c.gridx = 8;
        c.gridy = 12;
        checkPanel.add(singleclientsmallRecSize.getMyComboBox(), c);
        
        
        
        // multiple client
        c.gridx = 1;
        c.gridy = 13;
        c.insets = new Insets(0, 0, 0, 0);
        checkPanel.add(multipleClientButton.getMyCheckBox(), c);
        
        // number of Runs
        c.gridx = 2;
        c.gridy = 14;
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(numOfRunsLabelMultipleClient, c);
        c.gridx = 3;
        c.gridy = 14;
        checkPanel.add(numOfRunsMultipleClients.getMyComboBox(), c);
       
        
        // multiple client client number
        c.gridx = 2;
        c.gridy = 15;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(numClientLabel, c);
        c.gridx = 3;
        c.gridy = 15;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(minClientLabel, c);
        c.gridx = 4;
        c.gridy = 15;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(minNumberOfClients.getMyTextField(), c);
        c.gridx = 5;
        c.gridy = 15;
        checkPanel.add(maxClientLabel, c);
        c.gridx = 6;
        c.gridy = 15;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(maxNumberOfClients.getMyTextField(), c);
        c.anchor = GridBagConstraints.LINE_START;
        
        // multiple client file size
        c.gridx = 2;
        c.gridy = 16;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(fileSizeLabel, c);
        c.gridx = 3;
        c.gridy = 16;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_END;
        checkPanel.add(minMultipleClientFS, c);
        c.gridx = 4;
        c.gridy = 16;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(multipleClientMinFileSizeCbBox.getMyComboBox(), c);
        c.gridx = 5;
        c.gridy = 16;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_END;
        checkPanel.add(maxMultipleClientFS, c);
        c.gridx = 6;
        c.gridy = 16;
        c.insets = new Insets(5, 10, 0, 0);
        checkPanel.add(multipleClientMaxFileSizeCbBox.getMyComboBox(), c);
        
        
        
        // multiple clinet record size
        c.gridx = 2;
        c.gridy = 17;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(recordSizeLabel, c);
        c.gridx = 3;
        c.gridy = 17;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_END;
        checkPanel.add(MinMultipleClientRecSz, c);
        c.gridx = 4;
        c.gridy = 17;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(minRecordSize.getMyComboBox(), c);
        c.gridx = 5;
        c.gridy = 17;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_END;
        checkPanel.add(MaxMultipleClientRecSz, c);
        c.gridx = 6;
        c.gridy = 17;
        c.insets = new Insets(5, 10, 0, 0);
        c.anchor = GridBagConstraints.LINE_START;
        checkPanel.add(maxRecordSize.getMyComboBox(), c);
        
        // Final run Button
        c.gridx = 7;
        c.gridy = 24;
        c.anchor = GridBagConstraints.LINE_END;
        c.insets = new Insets(20, 0, 0, 0);
        checkPanel.add(runButton.getMyButton(), c);
        
        // cancelButton
        c.gridx = 8;
        c.gridy = 24;
        c.anchor = GridBagConstraints.LINE_END;
        c.insets = new Insets(20, 10, 0, 0);
        checkPanel.add(cancelbutton.getMyCancelButton(), c);
        
        add(checkPanel, BorderLayout.LINE_START);
        setBorder(BorderFactory.createEmptyBorder(40,40,40,40));
        setSize(1000, 500);
    }

     /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    static void createAndShowGUI() {
        //Create and set up the window.
        frame = new JFrame("P-Reg Customization Wizard");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new MainPanel();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);
        frame.pack();
       
        frame.setVisible(true);
    }

	public void run() {
		createAndShowGUI();
		
	}
}