import java.sql.ResultSet;
import java.util.HashMap;

public class MultiClientReport {
	private HashMap<Float, Float> writeThroughputData;
	private HashMap<Float, Float> readThroughputData;
	private float recordSize;
	private float fileSize;
	private String RegressionName;
	
	public MultiClientReport(float fsize, float rsize, String name){
		
		fileSize = fsize;
		recordSize = rsize;
		RegressionName = name;
		writeThroughputData = new HashMap<Float, Float>();
		readThroughputData = new HashMap<Float, Float>();
	}
	
	public String getRegressionName(){
		return RegressionName;
	}
	
	public void enterRegressionData(ResultSet rs) {
		try{
		while(rs!=null && rs.next()){
	        float numClients= rs.getFloat("num_clients");
	        float value = rs.getFloat("value");
	        String typeOfTest = rs.getString("type_of_test");
	        
	        if(typeOfTest.equalsIgnoreCase("multi_write")){
	        	writeThroughputData.put(new Float(numClients), new Float(value));
	        }
	        if(typeOfTest.equalsIgnoreCase("multi_read")){
	        	readThroughputData.put(new Float(numClients), new Float(value));
	        }
	        
	       //System.out.println("fs->" + numClients + " value->" + value );
	      }
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public HashMap<Float, Float> getWriteThroughputData(){
		return writeThroughputData;
	}
	
	public HashMap<Float, Float> getReadThroughputData(){
		return readThroughputData;
	}
	
	public float getRecordSize(){
		return recordSize;
	}
	
	public float getFileSize(){
		return fileSize;
	}
	
	public Float getWriteThroughput(float fSize){
		
		Float val;
		val = writeThroughputData.get(fSize);
		return val;
		
	}
	
	
	public Float getReadThroughput(float fSize){
		
		Float val;
		val = readThroughputData.get(fSize);
		return val;
		
	}
}
