#!/bin/bash
# Description: This file is the network performance diagnostic test script for 
# the pNFS regression suite and performance debugging tool chain. It calculates the performance of the link between all the nodes.
# Stage: 0 
# Author: Zainul Abedin (zja) & Swaroop Choudhari (svchoudh)
# Inputs: 
# Detailed Description: 
# Stage0 of the test suite is used to get Experimental setup information. 

count="0"
port=6001

if (([ -s "$nodes_list" ]) && ([ -r "$nodes_list" ]))
    then
    echo "Starting iperf server on every node"
    dsh -a -c -- "iperf -s -p$port > /dev/null" & 
   
    sleep 5
    for client in `cat $nodes_list`; do
	for server in `cat $nodes_list`; do
	    if [ "$client" != "$server" ] 
		then 
		let "count=0"
		while [ "$count" -lt "$num_runs" ]; do
		    dsh -m $client -- "iperf -c $server -p$port -f M >> "$PATH_TO_SAVE""$client"_"$server"_net_perf.txt"
		    let "count=$count+1"
		done
		dsh -m $client -- "cat "$PATH_TO_SAVE""$client"_"$server"_net_perf.txt | awk -f /usr/bin/net_perf.awk > /tmp/net_perf.tmp"
		temp="$SAVE_AS"
		dsh -m $client -- "insert_net_perf $DB_SERVER $num_runs $client $server \"$temp\" "
		dsh -m $client -- " rm -rf "$PATH_TO_SAVE""$client"_"$server"_net_perf.txt"
		dsh -m $client -- " rm -rf /tmp/net_perf.tmp"
	    fi
	done
    done
    echo "killing the iperf server"
    dsh -a -c -- "killall -sSIGKILL iperf"
else
    echo "STAGE0-DIAGNOSIS PHASE:  RAW NETWORK PERFORMACE - Invalid file:" $nodes_list
    exit
fi
