import java.io.File;
import java.io.FileWriter;
import java.util.*;

//import com.sun.org.apache.xalan.internal.xsltc.compiler.util.NumberType;

public class RunRegression {
	private DiagnosticTest mydiagnostic;
	private SingleClientTest mysingleclienttest;
	private MultipleClientTest mymultipleclienttest;
	private boolean runStageOne;
	private ExecuteCommand ec;
	private ConfigFileManager cfgMgr;
	private String nameOfTheRun;
	
	RunRegression(){
		mydiagnostic = new DiagnosticTest();
		mysingleclienttest = new SingleClientTest();
		mymultipleclienttest = new MultipleClientTest();
		nameOfTheRun = new String("");
		ec = new ExecuteCommand();
		
	}
	RunRegression(DiagnosticTest diag, SingleClientTest sct, MultipleClientTest mct, String name){
		mydiagnostic = diag;
		mysingleclienttest = sct;
		mymultipleclienttest = mct;
		nameOfTheRun = name;
	}
	
	private void createTempFiles(){
		cfgMgr.generateAllMachineFile("/usr/local/etc/machines.list");
		cfgMgr.generateClientFile("/usr/local/etc/group/clients");
		cfgMgr.generateStorageFile("/usr/local/etc/group/storage_nodes");
		cfgMgr.generateIoZoneClientFile("/tmp/preg/client_list");
		cfgMgr.generateDiskFile("/tmp/preg/disk_list");
		cfgMgr.generateMountPointFile("/tmp/preg/mountpoint_list");
		if(cfgMgr.getIoStat() == true){
			cfgMgr.generatePartitionFile("/tmp/preg/partition_list");
		}
		Utils.generateSizeInfoFile(mymultipleclienttest.getMinRecordSize(),
						mymultipleclienttest.getMaxRecordSize(), "/tmp/preg/recordsize_list");
		Utils.generateSizeInfoFile(mymultipleclienttest.getMinFileSize(), 
						mymultipleclienttest.getMaxFileSize(), "/tmp/preg/filesize_list");
	}
	
	private void createscript(){
			 try{
		FileWriter writer = new FileWriter(new File("config_script.sh"));
		writer.write("#!/bin/bash\n");
		writer.write("export PATH_TO_SAVE='/tmp/' \n" +
				"export SAVE_AS=\"" + nameOfTheRun + "\""+ "\n" +
				"export DB_SERVER=`uname -n`" + "\n" + 
				"export RUN_STAGE_ZERO="+ Utils.booleanToInterger(mydiagnostic.getRunDiagnostic())+ "\n" +
				"export STAGE_ZERO_num_runs=" + mydiagnostic.getNumberOfRuns() + "\n" +
				"export DISK_PERFORMANCE=" + Utils.booleanToInterger(mydiagnostic.getRunDiskPerf()) + "\n" +
				"export storage_nodes_list=\'/usr/local/etc/group/storage_nodes\'\n" +
				"export disk_list=\"/tmp/preg/disk_list\"\n" +
				"export RAW_NETWORK_PERFORMANCE=" + Utils.booleanToInterger(mydiagnostic.getRuniPerf()) + "\n" +
				"export nodes_list=\'/usr/local/etc/machines.list\' \n" +
				"export NET_SAT_PERFORMANCE="+ Utils.booleanToInterger(mydiagnostic.getRunNetSat()) + "\n" +
				"export TCP_DUMP="+ Utils.booleanToInterger(cfgMgr.getTcpDump()) + "\n" +
				"export IOSTAT="+ Utils.booleanToInterger(cfgMgr.getIoStat()) + "\n" +
				"export RUN_STAGE_ONE=" + Utils.booleanToInterger(runStageOne) + "\n" +
				"export VERSION=\"" + cfgMgr.getCodeVersion() + "\"\n" +
				"export FS=\"" + cfgMgr.getUnderlyingFs() + "\"\n" +
				"export SINGLE_CLIENT=" + Utils.booleanToInterger(mysingleclienttest.getRunSingleClientTest()) + "\n" +
				"export client_list='/usr/local/etc/group/clients'\n" +
				"export partition_list='/tmp/preg/partition_list'\n" +
				"export mount_point_list='/tmp/preg/mountpoint_list'\n" +
				"export SINGLE_CLIENT_num_runs=" + mysingleclienttest.getNumberOfRuns() + "\n" +
				"export SINGLE_CLIENT_AUTOREPORT=" + Utils.booleanToInterger(mysingleclienttest.getAutoReportTest()) + "\n" +
				"export SINGLE_CLIENT_LARGEFILES=" + Utils.booleanToInterger(mysingleclienttest.getRunLargeFileTest()) +"\n" +
				"export min_largefile_size=" + mysingleclienttest.getMinLargeFileSize() + "\n" +
				"export max_largefile_size=" + mysingleclienttest.getMaxLargeFileSize() +"\n" +
				"export largefile_recordsize="+ mysingleclienttest.getLargeFileRecordSize() + "\n" +
				"export SINGLE_CLIENT_SMALLFILES=" + Utils.booleanToInterger(mysingleclienttest.getRunSmallFileTest()) + "\n" +
				"export min_smallfile_size=" + mysingleclienttest.getMinSmallFileSize() + "\n" +
				"export max_smallfile_size=" + mysingleclienttest.getMaxSmallFileSize() + "\n" +
				"export smallfile_recordsize=" + mysingleclienttest.getSmallFileRecordSize() + "\n" +
				"export MULTIPLE_CLIENTS=" + Utils.booleanToInterger(mymultipleclienttest.getRunMultipleClientsTest()) + "\n" +
				"export MULTIPLE_CLIENTS_num_runs=" + mymultipleclienttest.getNumberOfRuns() + "\n" +
				"export min_num_clients=" + mymultipleclienttest.getMinNumberOfClients() + "\n" +
				"export max_num_clients=" + mymultipleclienttest.getMaxNumberOfClients() + "\n" +
				"export recordsize_list='/tmp/preg/recordsize_list' \n" +
				"export filesize_list='/tmp/preg/filesize_list' \n" +
				"export client_config_file=\"/tmp/preg/client_list\"\n" +
				"p-reg.sh > /tmp/preg/preg_run.log \n" +
				"exit");

		writer.flush();
		writer.close();
	 } 
	 catch(Exception e){
		 e.printStackTrace();
	 }

	}
	
	public void runTest(){
		createTempFiles();
		createscript();
		//save config in DB.
		dbConnection myconnect = new dbConnection();
		myconnect.createExecuteUpdate(
				"Insert into config_info " +
				"(entry_name,stage_zero," +
				"disk_perf,network_perf, netSat, stageZero_num_runs," +
				"stage_one,single_client, singleClient_num_runs," +
				"autoreport,large_files," +
				"min_largefile," +
				"max_largefile, largefile_recordsize," +
				"small_files," +
				"min_smallfile," +
				"max_smallfile, smallfile_recordsize," +
				"multiple_clients, multipleClient_num_runs," +
				"min_numclients," +
				"max_numclients," +
				"min_multiclient_filesize," +
				"max_multiclient_filesize, multiclient_min_recordsize, multiclient_max_recordsize)" +
				" values (\"" 
				+ nameOfTheRun +  "\","
				+ Utils.booleanToInterger(mydiagnostic.getRunDiagnostic()) + "," 
				+ Utils.booleanToInterger(mydiagnostic.getRunDiskPerf()) + "," 
				+ Utils.booleanToInterger(mydiagnostic.getRuniPerf()) + ","
				+ Utils.booleanToInterger(mydiagnostic.getRunNetSat()) + ","
				+ mydiagnostic.getNumberOfRuns() + ","
				+ Utils.booleanToInterger(runStageOne) + "," 
				+ Utils.booleanToInterger(mysingleclienttest.getRunSingleClientTest()) + ","
				+ mysingleclienttest.getNumberOfRuns() + ","
				+ Utils.booleanToInterger(mysingleclienttest.getAutoReportTest()) + "," 
				+ Utils.booleanToInterger(mysingleclienttest.getRunLargeFileTest()) + "," 
				+ mysingleclienttest.getMinLargeFileSize() + "," 
				+ mysingleclienttest.getMaxLargeFileSize() + ","
				+ mysingleclienttest.getLargeFileRecordSize() + ","
				+ Utils.booleanToInterger(mysingleclienttest.getRunSmallFileTest()) + "," 
				+ mysingleclienttest.getMinSmallFileSize() + "," 
				+ mysingleclienttest.getMaxSmallFileSize() + ","
				+ mysingleclienttest.getSmallFileRecordSize() + ","
				+ Utils.booleanToInterger(mymultipleclienttest.getRunMultipleClientsTest()) + ","
				+ mymultipleclienttest.getNumberOfRuns() + ","
				+ mymultipleclienttest.getMinNumberOfClients() + "," 
				+ mymultipleclienttest.getMaxNumberOfClients() + "," 
				+ mymultipleclienttest.getMinFileSize() +"," 
				+ mymultipleclienttest.getMaxFileSize()+ "," 
				+ mymultipleclienttest.getMinRecordSize() + ","
				+ mymultipleclienttest.getMaxRecordSize() 
				+ ");");
		
		ec.runAndWait("chmod 777 config_script.sh");
		ec.runAndWait("./config_script.sh");
		ec.runAndWait("rm -rf config_script.sh");
		}
	
	public void setDiagnosticTest(DiagnosticTest val){
		mydiagnostic = val;
	}
	
	public void setSingleClientTest(SingleClientTest val){
		mysingleclienttest = val;
	}
	public void setMultipleClientTest(MultipleClientTest val){
		mymultipleclienttest = val;
	}
	public void setRunStageOne(boolean val){
		runStageOne = val;
	}
	
	public void setNameOfTheRun(String val){
		nameOfTheRun = val;
	}
	
	public void setConfigFileManager(ConfigFileManager val){
		cfgMgr = val;
	}
	
	public ConfigFileManager getConfigFileManager(){
		return cfgMgr;
	}
	
	public String getNameOfTheRun(){
		return nameOfTheRun;
	}
	
	public DiagnosticTest getDiagnosticTest(){
		return mydiagnostic;
	}
		
	public boolean getRunStageOne(){
		return runStageOne;
	}
	public SingleClientTest getSingleClientTest(){
		return mysingleclienttest;
	}
	public MultipleClientTest getMultipleClientTest(){
		return mymultipleclienttest;
	}
	
	
}
